program RCube;

{$R *.res}

uses
  SysUtils,
  sdl,
  SDLDraw,
  sdlgui,
  SDLFont,
  Main;

var Quit: Boolean;
    event: TSDL_Event;
    Gui: TSDLGui;
    Font: TSDLRasterFont;
begin
  SDLScreen := TSDLGLScreen.Create('SDL Rubik''s Cube',800,600,32,False);
  if SDLScreen.Surface=nil then
  begin
    SDLScreen.Free;
    SDL_Quit;
    Exit;
  end;
  if SDLScreen.OpenGLScreen then DefaultInitGL;

  Gui := TSDLGui.Create(nil);
  Font := TSDLRasterFont.Create(nil);
  Font.Load('Ariel','Font.png');
  GlobalFont := Font;
  Gui.HintFont := Font;
  fmRCube := TfmRCube.Create(Gui);

  Quit := true;
  while Quit do
  begin
    while SDL_PollEvent(@event)>0 do
    begin
      Gui.ProcessEvent(Event);
      if event.type_ = SDL_QUITEV then
        Quit := False;
    end;
    SDLScreen.Clear(nil,0);
    fmRCube.Draw3DScene;
    Gui.Update;
    SDLScreen.Flip;
  end;

  Gui.Free;
  Font.Free;

  SDLScreen.Free;

  SDL_Quit;
end.
